﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;

namespace AddRemoveColumn
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            List<Security> securities = new List<Security>
                                            {
                                                new Security {SecurityName = "Microsoft", IndustryName = "IT", Price = "30", Ticker = "MSFT", NewAttribute = "123"},
                                                new Security {SecurityName = "Fidelity", IndustryName = "Finance", Price = "65", Ticker = "FIL", NewAttribute = "555"},
                                                new Security {SecurityName = "Facebook", IndustryName = "IT", Price = "50", Ticker = "FB", NewAttribute = "925"},
                                                new Security {SecurityName = "Indial Oil", IndustryName = "Energy", Price = "20", Ticker = "IO", NewAttribute = "855"}
                                            };

            xamGrid1.ItemsSource = securities;
        }

        private void btnAdd_Click(object sender, RoutedEventArgs e)
        {
            TextColumn newCol = new TextColumn();
            newCol.Key = "NewAttribute";
            newCol.HeaderText = "New Attribute";
            newCol.Width = new ColumnWidth(100, false);
            
            GroupColumn virtualSection = new GroupColumn();
            virtualSection.Key = "Virtual";
            virtualSection.HeaderText = "Virtual";
            virtualSection.Columns.Add(newCol);

            xamGrid1.Columns.Add(virtualSection);
        }

        private void btnRemove_Click(object sender, RoutedEventArgs e)
        {
            var virtualSection = this.xamGrid1.Columns["Virtual"] as GroupColumn;
            virtualSection.Columns.Clear();
            xamGrid1.Columns.Remove(virtualSection);
        }
    }

    public class Security
    {
        public Security()
        {
        }

        public Security(string securityName, string ticker, string industry, string price, string newAttribute)
        {
            this.SecurityName = securityName;
            this.Ticker = ticker;
            this.IndustryName = industry;
            this.Price = price;
            this.NewAttribute = newAttribute;
        }

        public string SecurityName { get; set; } 
        public string Ticker { get; set; }
        public string IndustryName { get; set; }
        public string Price { get; set; }
        public string NewAttribute { get; set; }
    }
}
